#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;

long long nwd(long long a, long long b)
{
  return (a == 0 || b == 0) ? a+b : nwd(b%a, a);
}

/*struct Ulamek {
  long long l, m;
  Ulamek(long long x=0) : l(x), m(1) {};
  Ulamek(long long x, long long y) {
    long long d = nwd(x, y);
    if (d > 0) {
      l = x / d;
      m = y / d;
    } else {l = 0; m = 1;}
  }
  Ulamek operator*(const Ulamek& u2) const
  {
    long long d1 = nwd(l, u2.m);
    long long d2 = nwd(u2.l, m);
    return Ulamek((l / d1) * (u2.l / d2), (m / d2) * (u2.m / d1));
  }
  bool operator<(const Ulamek& u2) const
  {
    long long d1 = nwd(l, u2.l);
    long long d2 = nwd(u2.m, m);
    return (l / d1) * (u2.m / d2) < (m / d2) * (u2.l / d1);
  }
  bool operator<=(const Ulamek& u2) const
  {
    long long d1 = nwd(l, u2.l);
    long long d2 = nwd(u2.m, m);
    return (l / d1) * (u2.m / d2) <= (m / d2) * (u2.l / d1);
  }
  Ulamek operator-(const Ulamek& u2) const
  {
    long long d = nwd(m, u2.m);
    return Ulamek(l*(u2.m/d) - u2.l * (m/d), (m/d) * u2.m);
  }
  void p() {printf("%lld/%lld", l, m);}
};*/
#define Ulamek(a, b) ((long double)(a) / (b))
typedef long double Ulamek;

char lewa[3][12], prawa[3][12];
int gile[3];
int p;

int num;
char* jedn[6];
Ulamek norm[6];

inline int znajdz(char* co)
{
  for (int i = 0; i < num; i++) {
    if (strcmp(co, jedn[i]) == 0) return i;
  }
  return -1;
}

inline void poprzeliczaj(int i, Ulamek ile)
{
  if (norm[i] >= 0) return;
  //printf("%d [%s] mamy ", i, jedn[i]);ile.p();putchar('\n');
  norm[i] = ile;
  for (int j = 0; j < p; j++) {
    if (strcmp(jedn[i], lewa[j]) == 0) {
      poprzeliczaj(znajdz(prawa[i]), ile * Ulamek(1, gile[j]));
    }
    if (strcmp(jedn[i], prawa[j]) == 0) {
      poprzeliczaj(znajdz(lewa[i]), ile * Ulamek(gile[j], 1));
    }
  }
}

struct Opis {
  int wart;
  char nazwa[12];
  Ulamek norm;
  bool operator<(const Opis& o) const {
    return norm < o.norm;
  }
};

Opis wzorzec[100000];

inline void normalizuj(Opis& o)
{
  int i = znajdz(o.nazwa);
  if (i >= 0)o.norm = norm[i] * o.wart; else o.norm = o.wart;
}

inline void dodaj_jedn(char* j)
{
  int i = znajdz(j);
  //printf("%s ma juz numer %d\n", j, i);
  if (i < 0) {
    jedn[num] = j;
    norm[num++] = Ulamek(-1, 1);
  }
}

int main()
{
  int t;
  scanf("%d", &t);
  while (t > 0) {
    t--;
    scanf("%d", &p);
    for (int i = 0; i < p; i++) {
      scanf("%*d %s = %d %s", lewa[i], &gile[i], prawa[i]);
    }
    num = 0;
    for (int i = 0; i < p; i++) {
      dodaj_jedn(lewa[i]);
      dodaj_jedn(prawa[i]);
    }
    for (int i = 0; i < num; i++) {
      //norm[i].p(); putchar('\n');
      poprzeliczaj(i, 1);
    }
    for (int i = 0; i < p; i++) {
      //printf("1 %s = %d %s\n", lewa[i], gile[i], prawa[i]);
      //printf("L = ");norm[znajdz(lewa[i])].p(); 
      //printf(", P = ");(norm[znajdz(prawa[i])]*gile[i]).p(); 
      //putchar('\n');
    }
    int w;
    scanf("%d", &w);
    for (int i = 0; i < w; i++) {
      scanf("%d %s", &wzorzec[i].wart, wzorzec[i].nazwa);
      normalizuj(wzorzec[i]);
    }
    sort(wzorzec, wzorzec + w);
    int q;
    scanf("%d", &q);
    for (int i = 0; i < q; i++) {
      Opis o;
      scanf("%d %s", &o.wart, o.nazwa);
      normalizuj(o);
      Opis* wsk = lower_bound(wzorzec, wzorzec + w, o);
      int best = wsk - wzorzec;
      if (best > 0) {
	if (best >= w || o.norm - wzorzec[best-1].norm <= wzorzec[best].norm - o.norm) best--;
      }
      printf("%d %s\n", wzorzec[best].wart, wzorzec[best].nazwa);
    }
  }
}
