#include <cstdio>
#include <vector>
#include <list>
#include <cmath>
#include <algorithm>
using namespace std;
const int INF = 1<<30;
#define sqr(a) ((long long)(a)*(a))
typedef long long int64;
extern struct PUNKT srodek;

inline long long myllabs(long long x) {
  return (x>=0?x:-x);
}

struct PUNKT {
  int64 X, Y;
  
   
  pair<int64, int64> a;
  void policz() {
    
    int64 dx = X - srodek.X, dy = Y-srodek.Y;
    int64 d = myllabs(dx) + myllabs(dy); 
    if (dy >= 0 && dx >= 0) a= make_pair(dy,     d);
    else if (dy >= 0 && dx <  0) a=make_pair(2*d-dy, d);
    else if (dy <  0 && dx >= 0) a= make_pair(4*d+dy, d);
    else if (dy <  0 && dx <  0) a= make_pair(2*d-dy, d);
    else a= make_pair(0,1);
  };
  
  bool operator < (const PUNKT& p) const {
    pair<int64, int64> a1 = a, a2 = p.a;
    int sgn = (a1.second*a2.second < 0 ? -1:1);
    int64 w = sgn*a1.first*a2.second - sgn*a1.second*a2.first;
    if (w==0)
      return sqr(X - srodek.X) + sqr(Y - srodek.Y) <
             sqr(p.X - srodek.X) + sqr(p.Y - srodek.Y);
    return w<0;
  }      
} srodek; 

void posortuj_biegunowo(vector<PUNKT>& pts) {
  srodek = pts[0];
  for (int i=pts.size()-1; i >= 0; --i) 
    if (pts[i].Y < srodek.Y) srodek = pts[i];
  for (int i=0; i < pts.size(); ++i) {
    pts[i].policz();
  }
  sort(pts.begin(), pts.end());
}

inline int64 skret(PUNKT& a, PUNKT& b, PUNKT& c) {
  return (a.Y-b.Y)*c.X + (b.X-a.X)*c.Y + a.X*b.Y - b.X*a.Y;
}

inline int strona(PUNKT& p1, PUNKT& p2, PUNKT& p) {
  int64 det = p1.X*p2.Y + p2.X*p.Y + p.X*p1.Y 
            - p1.Y*p2.X - p2.Y*p.X - p.Y*p1.X;
  if (det < 0) return -1;
  if (det > 0) return 1;
  return 0;	    
}

inline void graham(vector<PUNKT>& pts, vector<PUNKT>& out) {
  posortuj_biegunowo(pts);
  for (int i=0; i < pts.size(); ++i) {
    while (out.size() >= 2) {
      if (skret(out[out.size()-1], out[out.size()-2], pts[i]) <= 0) break; //<
      out.pop_back();
    }
    out.push_back(pts[i]);
  }
}

vector<PUNKT> pts;

struct PROSTA {
  int64 A,B,C;
  
 
  PROSTA(PUNKT& p1,  PUNKT& p2, PUNKT& p3) {
    A = p1.X-p2.X;
    B = p2.Y-p1.Y;
    C = -A*p1.X - B*p1.Y;
    
    PUNKT o;
    o.X = p1.X + A;
    o.Y = p1.Y + B;
    if (strona(p1, p2, o) != strona(p1,p2, p3)) {
      A=-A;
      B=-B;
    }
  }
  
  PROSTA(PROSTA& pr, PUNKT& p2, PUNKT& p3) {
    A = -pr.A;
    B = -pr.B;
    C = pr.C;
  }
};

inline int64 odl2(PUNKT& p, PUNKT& k) {
  return sqr((long long)p.X-k.X)+sqr((long long)p.Y-k.Y);
}

inline double kat(PROSTA& p, int a, int b) {
  PROSTA k(pts[a], pts[b], pts[(b+1)%pts.size()]);
  return ( p.A*k.A + p.B*k.B ) / 
        sqrt((long double)(sqr(k.A)+sqr(k.B))*(sqr(p.A)+sqr(p.B)));
}

void najdluzsza_odl(vector<PUNKT>& rr) {
  pts.clear();
  long long sx=0, sy=0;
  graham(rr, pts);
  for (int i=0; i < rr.size(); ++i) {
      sx += rr[i].X;
      sy += rr[i].Y;
  }
  sx /= pts.size();
  sy /= pts.size();
  int x=1, z=0;
  PUNKT ppp;
  ppp.X=sx;
  ppp.Y=sy;
  PROSTA p(pts[0], pts[1], ppp);
  int64 D=0;
  for (int i=2; i < pts.size(); ++i) {
    int64 d = myllabs(p.A*pts[i].X + p.B*pts[i].Y + p.C);
    if (d > D) {
      D = d;
      z = i;
    } 
  }
  PROSTA k(p, pts[z], ppp);
  int typ[2];
  typ[0]=1;
  typ[1]=0;
  int64 best=0;
  
  for (int i=0; i < 2*pts.size() + 2; ++i) {
    int px = x-1;
    if (px < 0) px = pts.size()-1;
    int pz = z-1;
    if (pz < 0) pz = pts.size()-1;
    
    int nx = x+1;
    if (nx == pts.size()) nx = 0;
    int nz = z+1;
    if (nz == pts.size()) nz = 0;
    
    best >?= odl2(pts[x], pts[z]);
    best >?= odl2(pts[nx], pts[z]);
    best >?= odl2(pts[nz], pts[x]);
    best >?= odl2(pts[nz], pts[nx]);

    best >?= odl2(pts[x], pts[z]);
    best >?= odl2(pts[px], pts[z]);
    best >?= odl2(pts[pz], pts[x]);
    best >?= odl2(pts[pz], pts[px]);

//    best >?= odl2(pts[(x+1)%pts.size()], pts[z]);
//    best >?= odl2(pts[(z+1)%pts.size()], pts[x]);
//    best >?= odl2(pts[(x+1)%pts.size()], pts[(z+1)%pts.size()]);
    double alpha = kat(p, x, nx);
    double beta = kat(k, z, nz);
    if (alpha > beta) {
      if (typ[0]) {
        typ[0]=0;
	p = PROSTA(k, pts[x], ppp);
      } else {
        typ[0]=1;
	p = PROSTA(pts[x], pts[nx], ppp);
	x = nx;
      }
    } else {
      if (typ[1]) {
        typ[1]=0;
	k = PROSTA(p, pts[z], ppp);
      } else {
        typ[1]=1;
	k = PROSTA(pts[z], pts[nz], ppp);
	z=nz;
      }
    }
  }
  printf("%lld\n", best);
}


vector<PUNKT> e;

int main(void) {
  int T;
  scanf("%d", &T);
  while(T--) {
    int n,m;
    scanf("%d", &n);
    m=n;
    e.clear();
    while (n--) {
      int x,y;
      scanf("%d %d", &x, &y);
      PUNKT p;
      p.X=x;
      p.Y=y;
      e.push_back(p);
    }
    if (m>2) {
      najdluzsza_odl(e);
    }else printf("%lld\n", odl2(e[0], e[1]));
  }  

  return 0;
}
