#include <cstdio>
#include <cctype>
#include <cstdlib>
#include <cstring>
#include <queue>
#include <vector>
using namespace std;

#define MAX_PAT_LEN 60100


int solutions;

class Trie {
public:
  int ilosc, iloscNodes;
  struct node {
    vector<pair<char, node*> > next;
    node *prev;
    int nr;
    char odw, rev;
    int terminal_len;
    node(int x, node* t=0, char r=0):odw(0), prev(t), rev(r), nr(x) {
      terminal_len=0;
    }
  }  *root;
    
    void add(char* s, int w=0, node* T=0) {
      if (!T) T = root;
      if (!*s) T->terminal_len = w;
      else {
        int i=0;
        for (i=0; i < T->next.size(); ++i) {
	  if (T->next[i].first == *s) break;
	}
	if (i==T->next.size()) {
	   T->next.push_back(make_pair(*s, new node(iloscNodes++, T, *s)));
	}
	add(s+1, w+1, T->next[i].second);
      }
    }
    
    Trie() { ilosc=0; iloscNodes=1; root=new node(0); }
    void usun(node* T) {
      for (int i=0; i < T->next.size(); ++i) {
        if (T->next[i].second) usun(T->next[i].second);
      }
      delete T;
    }
    ~Trie() {
      usun(root);
    }
};

class OfflineAC : public Trie {
  node* delta[MAX_PAT_LEN+1][30];
public:
   void build( ) {
     for (int i=0; i < 30; ++i) delta[0][i]=root;
     queue<node*> Q;
     Q.push(root);
     while (!Q.empty()) {
       node* x = Q.front(); Q.pop();
       for (int i=0; i < x->next.size(); ++i)
         if (x->next[i].second && !x->next[i].second->odw) {
	   x->next[i].second->odw = 1;
	   Q.push(x->next[i].second);
	 }
       if (x==root) continue;
       node* tmp = delta[x->prev->nr][x->rev];
       delta[x->prev->nr][x->rev]=x;
       if (!x->terminal_len) x->terminal_len=tmp->terminal_len;
       else if (tmp->terminal_len)
         x->terminal_len <?= tmp->terminal_len;
	 
       for (int i=0; i < 30; ++i) delta[x->nr][i] = delta[tmp->nr][i];
       
       for (int i=0; i < tmp->next.size(); ++i)
         delta[x->nr][tmp->next[i].first] = tmp->next[i].second;
     }
   }
   
   void search(char* text) {
     solutions = 0;
     char* s = text-1;
     for (node* state = root; *text; ++text) {
       state = delta[state->nr][*text];
       if (state->terminal_len) {
         if (state->terminal_len + s <= text) {
	   solutions++;
	   s = text;
	 }
       }
     }
   }
};

char s[MAX_PAT_LEN+1];
char text[5000100];

int main() {
  int T;
  scanf("%d", &T);
  while (T--) {
    int n;
    scanf("%d", &n);
    gets(s);
    OfflineAC* A = new OfflineAC;
    while (n--) {
      gets(s);
      for (char* p=s; *p; ++p) {
        if (isalpha(*p)) {
	  *p = *p-'A'+1;
	}else 
	  *p = 'Z'-'A'+2;
      }
      A->add(s);      
    }
    A->build();
    gets(text);
    for(char* p=text; *p; ++p) {
        if (isalpha(*p)) {
	  *p = *p-'A'+1;
	}else 
	  *p = 'Z'-'A'+2;
    }
    A->search(text);
    printf("%d\n",solutions);
    delete A;
  }
  return 0;
}

