#include <queue>
#include <cstdio>
using namespace std;

struct Droga {
  int to;
  int len;
  int t, a, l;
};

int n, m;
vector<Droga> drogi[50000];

const int INF = 1<<30;

inline int czekaj(int kiedy, Droga& d)
{
  if (d.t == 0 && d.a == 0 && d.l == 0) return kiedy;
  if (kiedy < d.a) {
    if (kiedy < d.a-d.t+d.l) return kiedy;
    return d.a;
  }
  kiedy -= d.a;
  if (kiedy % d.t < d.l) return kiedy + d.a;
  return ((kiedy / d.t + 1) * d.t) + d.a;
}

inline int dijkstra()
{
  typedef pair<int,int> ii;
  priority_queue<ii, vector<ii>, greater<ii> > kop;
  int odl[50000];
  bool done[50000];
  kop.push(make_pair(0, 0));
  odl[0] = 0;
  done[0] = false;
  for (int i = 1; i < n; i++) {odl[i] = INF; done[i] = false;}
  while (!kop.empty()) {
    int gdzie = kop.top().second;
    int kiedy = kop.top().first;
    kop.pop();
    if (done[gdzie]) continue;
    done[gdzie] = true;
    if (gdzie == n-1 || kiedy >= INF) return odl[gdzie];
    vector<Droga>::iterator it = drogi[gdzie].begin();
    while (it != drogi[gdzie].end()) {
      if (!done[it->to]) {
	int t = czekaj(kiedy, *it);
	if (t + it->len < odl[it->to]) {
	  odl[it->to] = t + it->len;
	  kop.push(make_pair(odl[it->to], it->to));
	}
      }
      it++;
    }
  }
  return odl[n-1];
}

int main() {
  int t;
  scanf("%d", &t);
  while (t > 0) {
    t--;
    scanf("%d %d", &n, &m);
    for (int i = 0; i < n; i++) drogi[i].clear();
    for (int i = 0; i < m; i++) {
      int from;
      Droga d;
      scanf("%d %d %d %d %d %d", &from, &d.to, &d.len, &d.t, &d.a, &d.l);
      from--;
      d.to--;
      drogi[from].push_back(d);
    }
    int res = dijkstra();
    if (res < INF) printf("%d\n", res); else puts("NIE");
  }
  return 0;
}
